# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AccessMode',
    'AdvertiseMode',
    'DataResilienceTier',
    'FailoverTier',
    'NfsDirectoryActionOnVolumeDeletion',
    'PerformanceTier',
    'SCType',
    'VolumeBindingMode',
    'VolumeExpansion',
]


class AccessMode(str, Enum):
    """
    Storage Class Access Mode
    """
    READ_WRITE_ONCE = "ReadWriteOnce"
    """
    Read Write Once (RWO) access mode
    """
    READ_WRITE_MANY = "ReadWriteMany"
    """
    Read Write Many (RWX) access mode
    """


class AdvertiseMode(str, Enum):
    """
    Advertise Mode
    """
    ARP = "ARP"
    """
    ARP advertise mode
    """
    BGP = "BGP"
    """
    BGP advertise mode
    """
    BOTH = "Both"
    """
    both ARP and BGP advertise mode
    """


class DataResilienceTier(str, Enum):
    """
    Allow single data node failure
    """
    NOT_DATA_RESILIENT = "NotDataResilient"
    """
    Not data resilient
    """
    DATA_RESILIENT = "DataResilient"
    """
    Data resilient
    """


class FailoverTier(str, Enum):
    """
    Failover speed: NA, Slow, Fast
    """
    NOT_AVAILABLE = "NotAvailable"
    """
    Not available Failover Tier
    """
    SLOW = "Slow"
    """
    Slow Failover Tier
    """
    FAST = "Fast"
    """
    Fast Failover Tier
    """
    SUPER = "Super"
    """
    Super Failover Tier
    """


class NfsDirectoryActionOnVolumeDeletion(str, Enum):
    """
    The action to take when a NFS volume is deleted. Default is Delete
    """
    DELETE = "Delete"
    """
    When the volume is deleted, delete the directory
    """
    RETAIN = "Retain"
    """
    When the volume is deleted, retain the directory
    """


class PerformanceTier(str, Enum):
    """
    Performance tier
    """
    UNDEFINED = "Undefined"
    """
    Undefined Performance Tier
    """
    BASIC = "Basic"
    """
    Basic Performance Tier
    """
    STANDARD = "Standard"
    """
    Standard Performance Tier
    """
    PREMIUM = "Premium"
    """
    Premium Performance Tier
    """
    ULTRA = "Ultra"
    """
    Ultra Performance Tier
    """


class SCType(str, Enum):
    """
    Type of the storage class.
    """
    NATIVE = "Native"
    """
    Native storage class
    """
    RWX = "RWX"
    """
    RWX storage class
    """
    BLOB = "Blob"
    """
    Blob storage class
    """
    NFS = "NFS"
    """
    NFS storage class
    """
    SMB = "SMB"
    """
    SMB storage class
    """


class VolumeBindingMode(str, Enum):
    """
    Binding mode of volumes: Immediate, WaitForFirstConsumer
    """
    IMMEDIATE = "Immediate"
    """
    Immediate binding mode
    """
    WAIT_FOR_FIRST_CONSUMER = "WaitForFirstConsumer"
    """
    Wait for first consumer binding mode
    """


class VolumeExpansion(str, Enum):
    """
    Volume can be expanded or not
    """
    ALLOW = "Allow"
    """
    Allow volume expansion
    """
    DISALLOW = "Disallow"
    """
    Disallow volume expansion
    """
